'use strict';

angular.module('adf.widget.electre.lavoisier')
    .directive('lavoisierChartContent', [
        "domService", "lavoisierHttpRequestService", "LAVOISIER_TEMPLATES_PATH", "parserService",
        function (domService, lavoisierHttpRequestService, LAVOISIER_TEMPLATES_PATH, parserService) {
            return {
                scope : {
                    control : '='
                },
                link : function (scope, element, attrs) {
                    scope.control.processing();
                    scope.success = false; scope.failedRequest = false;

                    lavoisierHttpRequestService.getResult_2(scope.control.httpConfig)
                    .then(
                        function (value) {
                            try {
                                var html = parserService.htmlDomFromString(value);
                                var polymer_highcharts = html.getElementsByTagName("polymer-highchart"), polymer = [];
                                for (var index = 0 ; index < polymer_highcharts.length ; index++) {
                                    polymer[index] = document.createElement("polymer-highchart");
                                    polymer[index].setAttribute('no-menu', true);
                                    polymer[index].setAttribute('chart-config', polymer_highcharts[index].getAttribute('chart-config'));
                                }

                                element.append(polymer);
                            } catch (e) { scope.failedRequest = false; throw e; }
                        }, function (error) {
                            scope.failedRequest = true;
                            throw "An error has occurred during the request. Please verify you have entered valid info.";
                        }
                    ).then(
                        function () {
                            scope.control.success();
                            scope.success = true;
                        }, function (error) {
                            if (scope.failedRequest)    scope.control.requestFailed();
                            else                        scope.control.processingFailed();
                        }
                    );
                }
            };
        }
    ]);